﻿using AutoMapper;
using Models.ReqModel;
using Models.Table;
using Repositories.IRepository.IBussiness;
using Repositories.Repository.Bussiness;
using Services.Interface;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Services
{
    public class InvService : BaseService<InvSummary>, IInvService
    {
        private readonly IInvSummaryRepository _invSummaryRepository;
        private readonly IInvDetailRepository _invDetailRepository;
        public IMapper mapper;
        public InvService(IInvSummaryRepository invSummaryRepository, IInvDetailRepository invDetailRepository, IMapper _mapper)
        {
            base.BaseDal = invSummaryRepository;
            _invSummaryRepository = invSummaryRepository;
            _invDetailRepository = invDetailRepository;
            mapper = _mapper;
        }

        public Task<bool> AddInvLogs(InvReq model)
        {
            InvSummary inv = new InvSummary()
            {
                id = Guid.NewGuid().ToString(),
                useTime = model.useTime,
                useName = model.userName,
                invSum = model.invSum,
                resultSum = model.resultSum,
                overView = model.overView,
                createTime = DateTime.Now,
                updateTime = DateTime.Now,
            };

            List<Inventory> inList = new List<Inventory>();
            List<Inventory> lostList = new List<Inventory>();

            foreach (var detail in model.data)
            {
                if(detail.state == 0)
                {
                    inList.Add(new Inventory()
                    {
                        id = detail.invId,
                        state = "0",
                    });
                }else if(detail.state == 1)
                {
                    lostList.Add(new Inventory()
                    {
                        id = detail.invId,
                        lostFlag = "1",
                    });
                }

                inv.DetailList.Add(new InvDetail()
                {
                    invId = detail.invId,
                    typeName = detail.typeName,
                    sizeName = detail.sizeName,
                    epc = detail.epc,
                    state = detail.state,
                    createTime = DateTime.Now,
                    updateTime = DateTime.Now,
                });
            }

            return _invSummaryRepository.AddInvLogs(inv, inList, lostList);
        }
    }
}
